VERSION 5.00
Begin VB.Form AVIMakerFrm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "AVI Maker"
   ClientHeight    =   3435
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3435
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtStep 
      Height          =   285
      Left            =   3480
      TabIndex        =   15
      Text            =   "5"
      Top             =   120
      Width           =   615
   End
   Begin VB.TextBox edtFPS 
      Height          =   285
      Left            =   2280
      TabIndex        =   13
      Text            =   "25"
      Top             =   2160
      Width           =   615
   End
   Begin VB.TextBox edtNbCycles 
      Height          =   285
      Left            =   960
      TabIndex        =   12
      Text            =   "1"
      Top             =   1680
      Width           =   615
   End
   Begin VB.OptionButton optCircular 
      Caption         =   "&Circular"
      Enabled         =   0   'False
      Height          =   255
      Left            =   960
      TabIndex        =   9
      Top             =   1320
      Width           =   1095
   End
   Begin VB.OptionButton optBackForth 
      Caption         =   "&Back and forth"
      Height          =   255
      Left            =   960
      TabIndex        =   8
      Top             =   960
      Width           =   1575
   End
   Begin VB.OptionButton optOneWay 
      Caption         =   "&One way"
      Height          =   255
      Left            =   960
      TabIndex        =   6
      Top             =   600
      Value           =   -1  'True
      Width           =   1215
   End
   Begin VB.TextBox edtHeight 
      Height          =   285
      Left            =   1920
      TabIndex        =   5
      Text            =   "288"
      Top             =   120
      Width           =   615
   End
   Begin VB.TextBox edtWidth 
      Height          =   285
      Left            =   1080
      TabIndex        =   3
      Text            =   "352"
      Top             =   120
      Width           =   615
   End
   Begin VB.CommandButton btnClose 
      Caption         =   "&Close"
      Height          =   495
      Left            =   2520
      TabIndex        =   1
      Top             =   2880
      Width           =   1215
   End
   Begin VB.CommandButton btnStart 
      Caption         =   "&Start"
      Default         =   -1  'True
      Height          =   495
      Left            =   840
      TabIndex        =   0
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "Step:"
      Height          =   255
      Left            =   3000
      TabIndex        =   16
      Top             =   120
      Width           =   495
   End
   Begin VB.Label lblFrame 
      Alignment       =   2  'Center
      Height          =   195
      Left            =   120
      TabIndex        =   14
      Top             =   2520
      Width           =   4440
   End
   Begin VB.Image imgPreview 
      BorderStyle     =   1  'Fixed Single
      Height          =   1515
      Left            =   2640
      Stretch         =   -1  'True
      Top             =   480
      Width           =   1950
   End
   Begin VB.Label lblfps 
      Caption         =   "Frames per second (1 - 30):"
      Height          =   195
      Left            =   120
      TabIndex        =   11
      Top             =   2160
      Width           =   2040
   End
   Begin VB.Label Label4 
      Caption         =   "&Cycles:"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   1680
      Width           =   735
   End
   Begin VB.Label Label3 
      Caption         =   "&Type:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   600
      Width           =   735
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "x"
      Height          =   255
      Left            =   1720
      TabIndex        =   4
      Top             =   120
      Width           =   135
   End
   Begin VB.Label Label1 
      Caption         =   "&Movie size:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "AVIMakerFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public pic As Object, nStep As Integer, szFileName As String
Public bRunning As Boolean

Private Declare Function SetRect Lib "user32.dll" _
    (ByRef lprc As AVI_RECT, ByVal xLeft As Long, ByVal yTop As Long, ByVal xRight As Long, ByVal yBottom As Long) As Long 'BOOL
    
Const ONEWAY = 1
Const BACKANDFORTH = 2
Const CIRCULARRIGHT = 3

Private Sub btnStart_Click()
    If bRunning Then
        bRunning = False
        Exit Sub
    End If
 
    Dim nType As Integer, nbCycles As Integer, nCurCycle As Integer
    If optOneWay Then
        nType = ONEWAY
    ElseIf optBackForth Then
        nType = BACKANDFORTH
    ElseIf optCircular Then
        nType = CIRCULARRIGHT
    End If
    nbCycles = edtNbCycles.Text
    If nbCycles <= 0 Or nType = ONEWAY Then nbCycles = 1
    nCurCycle = 1
    
    bRunning = True
    btnStart.Caption = "&Stop"
    DoEvents
    
    Dim file As cFileDlg
    Dim InitDir As String
    Dim szOutputAVIFile As String
    Dim res As Long
    Dim pfile As Long 'ptr PAVIFILE
    Dim bmp As cDIB
    Dim ps As Long 'ptr PAVISTREAM
    Dim psCompressed As Long 'ptr PAVISTREAM
    Dim strhdr As AVI_STREAM_INFO
    Dim BI As BITMAPINFOHEADER
    Dim opts As AVI_COMPRESS_OPTIONS
    Dim pOpts As Long
    
    Set file = New cFileDlg
    'get an avi filename from user
    With file
        .DefaultExt = "avi"
        .DlgTitle = "Choose a filename to save AVI to..."
        .Filter = "AVI Files|*.avi"
        .OwnerHwnd = Me.hWnd
    End With
    szOutputAVIFile = "MyAVI.avi"
    If file.VBGetSaveFileName(szOutputAVIFile) <> True Then Exit Sub
    
    Dim wM As Integer, hM As Integer, fx As Double, xP As Integer, wMP As Integer
    wM = Val(edtWidth.Text)
    hM = Val(edtHeight.Text)
    fx = hM / pic.h
    wMP = Round(wM / fx)
    
    Dim alb As Object, rc As Object, rcOrg As Object
    Dim iFrame As Integer
    Set alb = pic.album
    
    xP = 0
    iFrame = 0
    nStep = txtStep.Text
    If nStep <= 0 Then nStep = 5
    szFileName = "c:\tmpPicture.bmp"    ' we are using the same temporary file for all the frames
    Do
        If xP + wMP > pic.w Then
            If nType = ONEWAY Then Exit Do
            If nType = BACKANDFORTH Then nStep = -nStep
        End If
        If xP < 0 Then
            If nType = BACKANDFORTH Then
                nCurCycle = nCurCycle + 1
                If nCurCycle > nbCycles Then Exit Do
                nStep = -nStep
            End If
        End If
        lblFrame.Caption = "Frame #" & iFrame
        
        Set rcOrg = pic.rcCrop
        Set rc = CreateObject("MyAlbum.rect")
        rc.x = xP
        rc.y = 0
        rc.w = wMP
        rc.h = pic.h
        Set pic.rcCrop = rc
        pic.SetCropRect xP, 0, xP + wMP, pic.h
        pic.Load True   ' Pre-load the picture so it will not be reloaded for each frame
        If Not pic.ConvertAndResize2(szFileName, 1, wM, hM, 2, 0, 0) Then
            bRunning = False
        Else
            DoEvents
            ' Update the preview Image control
            imgPreview.Picture = LoadPicture(szFileName)
            imgPreview.Refresh
            
            If iFrame = 0 Then  ' This is the first frame, initialize the AVI file
            '    Open the file for writing
                res = AVIFileOpen(pfile, szOutputAVIFile, OF_WRITE Or OF_CREATE, 0&)
                If (res <> AVIERR_OK) Then GoTo error
            
                'Get the first bmp in the list for setting format
                Set bmp = New cDIB
                If bmp.CreateFromFile(szFileName) <> True Then
                    MsgBox "Could not load first frame !", vbExclamation, App.title
                    GoTo error
                End If
            
            '   Fill in the header for the video stream
                With strhdr
                    .fccType = mmioStringToFOURCC("vids", 0&)    '// stream type video
                    .fccHandler = 0&                             '// default AVI handler
                    .dwScale = 1
                    .dwRate = Val(edtFPS)                        '// fps
                    .dwSuggestedBufferSize = bmp.SizeImage       '// size of one frame pixels
                    Call SetRect(.rcFrame, 0, 0, bmp.Width, bmp.Height)       '// rectangle for stream
                End With
                
                'validate user input
                If strhdr.dwRate < 1 Then strhdr.dwRate = 1
                If strhdr.dwRate > 30 Then strhdr.dwRate = 30
            
            '   And create the stream
                res = AVIFileCreateStream(pfile, ps, strhdr)
                If (res <> AVIERR_OK) Then GoTo error
            
                'get the compression options from the user
                'Careful! this API requires a pointer to a pointer to a UDT
                pOpts = VarPtr(opts)
                res = AVISaveOptions(Me.hWnd, _
                                    ICMF_CHOOSE_KEYFRAME Or ICMF_CHOOSE_DATARATE, _
                                    1, _
                                    ps, _
                                    pOpts) 'returns TRUE if User presses OK, FALSE if Cancel, or error code
                If res <> 1 Then 'In C TRUE = 1
                    Call AVISaveOptionsFree(1, pOpts)
                    GoTo error
                End If
    
                'make compressed stream
                res = AVIMakeCompressedStream(psCompressed, ps, opts, 0&)
                If res <> AVIERR_OK Then GoTo error
                
                'set format of stream according to the bitmap
                With BI
                    .biBitCount = bmp.BitCount
                    .biClrImportant = bmp.ClrImportant
                    .biClrUsed = bmp.ClrUsed
                    .biCompression = bmp.Compression
                    .biHeight = bmp.Height
                    .biWidth = bmp.Width
                    .biPlanes = bmp.Planes
                    .biSize = bmp.SizeInfoHeader
                    .biSizeImage = bmp.SizeImage
                    .biXPelsPerMeter = bmp.XPPM
                    .biYPelsPerMeter = bmp.YPPM
                End With
                
                'set the format of the compressed stream
                res = AVIStreamSetFormat(psCompressed, 0, ByVal bmp.PointerToBitmapInfo, bmp.SizeBitmapInfo)
                If (res <> AVIERR_OK) Then GoTo error
            
            Else    ' process the following frames
                bmp.CreateFromFile (szFileName) 'load the bitmap (ignore errors)
                res = AVIStreamWrite(psCompressed, _
                                    iFrame, _
                                    1, _
                                    bmp.PointerToBits, _
                                    bmp.SizeImage, _
                                    AVIIF_KEYFRAME, _
                                    ByVal 0&, _
                                    ByVal 0&)
                If res <> AVIERR_OK Then GoTo error
            End If
        
            xP = xP + nStep
            iFrame = iFrame + 1
        End If
        ' Restore the original picture cropping
        pic.SetCropRect 0, 0, 0, 0
        Set pic.rcCrop = rcOrg
    Loop While bRunning
    
error:
    bRunning = False
'   Now close the file
    Set file = Nothing
    Set bmp = Nothing
    
    If (ps <> 0) Then Call AVIStreamClose(ps)

    If (psCompressed <> 0) Then Call AVIStreamClose(psCompressed)

    If (pfile <> 0) Then Call AVIFileClose(pfile)

    Call AVIFileExit

    If (res <> AVIERR_OK) Then
        MsgBox "There was an error writing the file.", vbInformation, App.title
    End If
    
    btnStart.Caption = "&Start"
    
End Sub

Private Sub btnClose_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    optOneWay_Click
End Sub

Private Sub optOneWay_Click()
    edtNbCycles.Enabled = False
End Sub
Private Sub optBackForth_Click()
    edtNbCycles.Enabled = True
End Sub
Private Sub optCircular_Click()
    edtNbCycles.Enabled = True
End Sub

