VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form TheScrollerFrm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "The Scroller"
   ClientHeight    =   2595
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5340
   Icon            =   "TheScrollerFrm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2595
   ScaleWidth      =   5340
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnAVIMaker 
      Caption         =   "AVI maker..."
      Height          =   375
      Left            =   2040
      TabIndex        =   15
      Top             =   1560
      Width           =   1215
   End
   Begin VB.CommandButton btnQuit 
      Caption         =   "Quit"
      Height          =   495
      Left            =   4440
      TabIndex        =   14
      Top             =   1440
      Width           =   735
   End
   Begin VB.CommandButton btnSelectPicture 
      Caption         =   "&Select..."
      Height          =   255
      Left            =   4440
      TabIndex        =   13
      Top             =   840
      Width           =   855
   End
   Begin VB.CommandButton btnSelectAlbum 
      Caption         =   "&Select..."
      Height          =   255
      Left            =   4440
      TabIndex        =   11
      Top             =   480
      Width           =   855
   End
   Begin MSComDlg.CommonDialog cd1 
      Left            =   3000
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CheckBox ckbAutoQuit 
      Caption         =   "Auto Quit"
      Height          =   255
      Left            =   2040
      TabIndex        =   9
      Top             =   1200
      Width           =   1335
   End
   Begin VB.TextBox txtPicture 
      Height          =   285
      Left            =   1080
      TabIndex        =   4
      Text            =   "20"
      Top             =   840
      Width           =   2415
   End
   Begin VB.TextBox txtAlbum 
      Height          =   285
      Left            =   1080
      TabIndex        =   2
      Text            =   "20"
      Top             =   480
      Width           =   3255
   End
   Begin VB.TextBox txtStep 
      Height          =   285
      Left            =   1080
      TabIndex        =   8
      Text            =   "5"
      Top             =   1560
      Width           =   615
   End
   Begin VB.TextBox txtDelay 
      Height          =   285
      Left            =   1080
      TabIndex        =   6
      Text            =   "20"
      Top             =   1200
      Width           =   615
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   3600
      Top             =   0
   End
   Begin VB.CommandButton btnGo 
      Caption         =   "Go !"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3600
      TabIndex        =   10
      Top             =   1440
      Width           =   735
   End
   Begin VB.Label lblMessage 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "--"
      Height          =   495
      Left            =   165
      TabIndex        =   12
      Top             =   2040
      Width           =   4965
   End
   Begin VB.Label Label5 
      Caption         =   "Picture:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   615
   End
   Begin VB.Label Label4 
      Caption         =   "Album:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   615
   End
   Begin VB.Label Label3 
      Caption         =   "Step:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1560
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Delay (ms):"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   1200
      Width           =   975
   End
   Begin VB.Label lblVersion 
      Caption         =   "Label1"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2775
   End
End
Attribute VB_Name = "TheScrollerFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Dim MyAlbumApp As MyAlbum.Application, alb As MyAlbum.album, pic As MyAlbum.MyPicture
Dim MyAlbumApp As Object, alb As Object, pic As Object
Dim nMode As Integer, bNoScroll As Boolean
Dim nDir As Integer, bAutoStart As Boolean
Const DefaultMessage As String = "The Scroller" & vbCrLf & "Automatically scrolls a wide picture (panorama style) back and forth"

Const MODE_ANIM = 1
Const MODE_SELPIC = 2

Const DM_NORMAL = 0
Const DM_NOCOMMENT = &H10000


Private Sub Form_Load()
    nMode = MODE_ANIM
    lblMessage.Caption = DefaultMessage
    sIniFile = App.Path & "\TheScroller.ini"
    txtAlbum = GetProfileString("Settings", "Album")
    txtPicture = GetProfileString("Settings", "Picture")
    txtDelay = GetPrivateProfileInt("Settings", "Delay", 20, sIniFile)
    txtStep = GetPrivateProfileInt("Settings", "Step", 10, sIniFile)
    ckbAutoQuit = GetPrivateProfileInt("Settings", "AutoQuit", 0, sIniFile)

    On Error Resume Next
    Set MyAlbumApp = CreateObject("MyAlbum.Application")
    If Err.Number <> 0 Then
        MsgBox "Cannot start MyAlbum." & vbCrLf & "Exiting...", vbOKOnly Or vbExclamation, "Error!"
        End
    End If
    On Error GoTo 0
    lblVersion = "MyAlbum Version " & MyAlbumApp.Version
    
    bAutoStart = False
    If LCase(Command) = "/start" Or LCase(Command) = "-start" Then bAutoStart = True
    If GetKeyState(VK_CONTROL) And &H8000 Then bAutoStart = False
    If bAutoStart Then
        MyAlbumApp.Visible = True
        btnGo_Click
    Else
        activateApp
    End If
End Sub

Private Function loadAlbum() As Boolean
    loadAlbum = True
    Set alb = MyAlbumApp.loadAlbum(txtAlbum)
    If alb Is Nothing Then
        MsgBox "Cannot load album" & vbCrLf & "Enter the full path of the album to use.", vbOKOnly Or vbExclamation, "Error!"
        loadAlbum = False
    End If
End Function

Private Sub activateApp()
    MyAlbumApp.Visible = False
    Hide
    MyAlbumApp.Visible = True
    Show
End Sub

Private Sub btnGo_Click()
    If btnGo.Caption <> "Go !" Then
        alb.CloseDisplay
        btnGo.Caption = "Go !"
        Exit Sub
    End If
    If Not loadAlbum Then Exit Sub
    Dim iPic As Long, nb As Long
    nb = alb.nbPicture
    Set pic = alb.GetPictureByFileName(txtPicture)
    If pic Is Nothing Then
        MsgBox "Cannot find picture." & vbCrLf & "Enter the name of the picture.", vbOKOnly Or vbExclamation, "Error!"
        Exit Sub
    End If
    iPic = alb.CvtNumPic(pic.num, False)
    pic.bSelected = True
    alb.nCurrentPicture = iPic

    alb.nDisplayMode = (alb.nDisplayMode And &HFFFFFF00) Or DM_NORMAL Or DM_NOCOMMENT
    alb.DisplayPicture 0
    Dim view As Object 'MyAlbum.FullScreenView
    Set view = MyAlbumApp.GetFullScreenView
    ShowWindow view.hWnd, SW_SHOW
    'btnGo.Enabled = False
    btnGo.Caption = "Stop !"
    bNoScroll = (pic.w < view.w)
    view.xOrg = 0
    view.yOrg = 0
    Timer1.Interval = txtDelay
    Timer1.Enabled = True
    nDir = 1
    If bAutoStart Then Me.Visible = False
End Sub


Private Sub Timer1_Timer()
    If nMode = MODE_ANIM Then
        On Error GoTo StopTimer
        Dim view As Object 'MyAlbum.FullScreenView
        Dim xP As Integer
        Set view = MyAlbumApp.GetFullScreenView
        xP = view.xOrg + nDir * CInt(txtStep)
        If Not bNoScroll Then
            view.xOrg = xP
            view.MoveImage -1, False    ' Validate picture position and redraw window
            If view.xOrg <> xP Then nDir = -nDir
        End If
        Exit Sub
StopTimer:
        Me.Visible = True
        btnGo.Enabled = True
        btnGo.Caption = "Go !"
        Timer1.Enabled = False
        Set pic = Nothing
        Set alb = Nothing
        If ckbAutoQuit And bAutoStart Then Unload Me
    ElseIf nMode = MODE_SELPIC Then
        Dim iPic As Integer, nbSel As Integer
        nbSel = alb.nbSelectedPicture
        If nbSel <> 0 Then
            iPic = alb.nCurrentPicture
            Set pic = alb.GetVisiblePicture(iPic)
            txtPicture = pic.sShortFileName
            btnGo.Enabled = True
            btnSelectAlbum.Enabled = True
            btnSelectPicture.Enabled = True
            Timer1.Enabled = False
            nMode = MODE_ANIM
            Set pic = Nothing
            Set alb = Nothing
            lblMessage.Caption = DefaultMessage
            activateApp
        End If
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    WriteProfileString "Settings", "Album", txtAlbum.Text
    WriteProfileString "Settings", "Picture", txtPicture.Text
    WriteProfileString "Settings", "Delay", txtDelay.Text
    WriteProfileString "Settings", "Step", txtStep.Text
    WriteProfileString "Settings", "AutoQuit", ckbAutoQuit
End Sub

Private Sub btnSelectAlbum_Click()
    cd1.DialogTitle = "Select the album to use"
    cd1.Filter = "Albums (*.alb)|*.alb|All files (*.*)|*.*"
    cd1.FilterIndex = 0
    cd1.Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly
    cd1.filename = txtAlbum.Text
    cd1.CancelError = True
    On Error Resume Next
    cd1.ShowOpen
    If Err.Number = 0 Then txtAlbum.Text = cd1.filename
    On Error GoTo 0
End Sub

Private Sub btnSelectPicture_Click()
    If Not loadAlbum Then Exit Sub
    nMode = MODE_SELPIC
    alb.nbSelectedPicture = 0
    btnGo.Enabled = False
    btnSelectAlbum.Enabled = False
    btnSelectPicture.Enabled = False
    Timer1.Interval = 200
    Timer1.Enabled = True
    lblMessage.Caption = "Go to the MyAlbum window and select the picture you want to use."
End Sub

Private Sub btnQuit_Click()
    Unload Me
    End
End Sub

Private Sub btnAVIMaker_Click()
    If Not loadAlbum Then Exit Sub
    
    Dim iPic As Long, nb As Long
    nb = alb.nbPicture
    Set pic = alb.GetPictureByFileName(txtPicture)
    If pic Is Nothing Then
        MsgBox "Cannot find picture." & vbCrLf & "Enter the name of the picture.", vbOKOnly Or vbExclamation, "Error!"
        Exit Sub
    End If
    iPic = alb.CvtNumPic(pic.num, False)
    pic.bSelected = True
    alb.nCurrentPicture = iPic
    
    Load AVIMakerFrm
    Set AVIMakerFrm.pic = pic
    AVIMakerFrm.Show vbModal, Me
End Sub

