Attribute VB_Name = "commonFct"
Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Public Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

Public Const SW_SHOW = 5
Public Const WM_KEYDOWN = &H100
Public Const VK_END = &H23
Public Const VK_HOME = &H24
Public Const VK_PRIOR = &H21
Public Const VK_SHIFT = &H10
Public Const VK_CONTROL = &H11

Public Const WM_MOUSEACTIVATE = &H21
Public Const HTCAPTION = 2
Public Const WM_NCLBUTTONDOWN = &HA1

Public sIniFile As String

Public Function GetProfileString(ByVal sSection As String, ByVal sEntry As String) As String
    Dim sString As String, nLen As Long
    sString = Space(1024)
    nLen = GetPrivateProfileString(sSection, sEntry, "", sString, 1024, sIniFile)
    sString = Left(sString, nLen)
    GetProfileString = sString
End Function

Public Sub WriteProfileString(ByVal sSection As String, ByVal sKey As String, ByVal sValue As String)
    WritePrivateProfileString sSection, sKey, sValue, sIniFile
End Sub

